	<?php
	/**
	
	* @package BSI
	
	* @author BestSoft Inc see README.php
	
	* @copyright BestSoft Inc.
	
	* See COPYRIGHT.php for copyright notices and details.
	
	*/
	class bsiSearch
	
	{
	
		public $checkInDate = '';
	
		public $checkOutDate = '';	
		
		public $checkInStamp="";
		
		public $checkOutStamp="";
	
		public $mysqlCheckInDate = '';
	
		public $mysqlCheckOutDate = '';
	
		public $guestsPerRoom = 0;
		
		public $childsPerRoom=0;
	
		public $childPerRoom = 0;
	
		public $extrabedPerRoom = false;
	
		public $nightCount = 2;	
	
		public $fullDateRange;
	
		public $roomType = array();	
		
		public $addextras = array();	
		
		public $packageType = array();
		
		public $roomType1 = array();
		
		public $multiCapacity = array();
	
		public $searchCode = "SUCCESS";
		
		public $imageLoad = "";
		
		const SEARCH_CODE = "SUCCESS";
	
	
	
		function bsiSearch() {				
	
			$this->setRequestParams();
	
			$this->getNightCount();
	
			$this->checkSearchEngine();		
	
			$this->timeStamp();
			
			$this->checkBlock();
			
	
			if($this->searchCode == self::SEARCH_CODE){
	
				$this->loadMultiCapacity();			
	
				$this->loadRoomTypes();
				
				$this->extras();
				
				$this->loadPackage();
	
				$this->fullDateRange = $this->getDateRangeArray($this->mysqlCheckInDate, $this->mysqlCheckOutDate);
	
				$this->setMySessionVars();
	
			}	
	
		}
	
	
	
		private function setRequestParams() {		
	
			global $bsiCore;
	
			$tmpVar = isset($_POST['check_in'])? $_POST['check_in'] : NULL;
	
			$this->setMyParamValue($this->checkInDate, $bsiCore->ClearInput($tmpVar), NULL, true);
	
			$tmpVar = isset($_POST['check_out'])? $_POST['check_out'] : NULL; 
	
			$this->setMyParamValue($this->checkOutDate, $bsiCore->ClearInput($tmpVar), NULL, true); 
	
			$tmpVar = isset($_POST['capacity'])? $_POST['capacity'] : 0;
	
			$this->setMyParamValue($this->guestsPerRoom, $bsiCore->ClearInput($tmpVar), 0, true); 
	
			$tmpVar = isset($_POST['childcapacity'])? $_POST['childcapacity'] : 0;
	
			$this->setMyParamValue($this->childsPerRoom, $bsiCore->ClearInput($tmpVar), 0, true); 
			
			
	
			$this->mysqlCheckInDate = $bsiCore->getMySqlDate($this->checkInDate);   	  
	
			$this->mysqlCheckOutDate = $bsiCore->getMySqlDate($this->checkOutDate);	  			
	
		}
	
	
	
		
	
	
	
		private function setMyParamValue(&$membervariable, $paramvalue, $defaultvalue, $required = false){
	
			if($required){if(!isset($paramvalue)){$this->invalidRequest();}}
	
			if(isset($paramvalue)){  $membervariable = $paramvalue;}else{$membervariable = $defaultvalue;}
	
		}
	
		private function timeStamp(){
				$this->checkInStamp = mktime(0,0,0,substr($this->checkInDate,0,2),substr($this->checkInDate,3,2),substr($this->checkInDate,6,4));
				//$this->checkInStamp -= 43300;
				$this->checkInStamp -= 0;
				$this->checkOutStamp = mktime(0,0,0,substr($this->checkOutDate,0,2),substr($this->checkOutDate,3,2),substr($this->checkOutDate,6,4));
				//$this->checkOutStamp -= 43300;
				$this->checkOutStamp -= 0;
				$_SESSION[checkindate] = $this->checkInStamp;
				$_SESSION[checkoutdate] = $this->checkOutStamp;
			}
	
		private function setMySessionVars(){
	
			if(isset($_SESSION['sv_checkindate'])) unset($_SESSION['sv_checkindate']);
	
			if(isset($_SESSION['sv_checkoutdate'])) unset($_SESSION['sv_checkoutdate']);
	
			if(isset($_SESSION['sv_mcheckindate'])) unset($_SESSION['sv_mcheckindate']);
	
			if(isset($_SESSION['sv_mcheckoutdate'])) unset($_SESSION['sv_mcheckoutdate']);
	
			if(isset($_SESSION['sv_nightcount'])) unset($_SESSION['sv_nightcount']);
	
			if(isset($_SESSION['sv_guestperroom'])) unset($_SESSION['sv_guestperroom']);
	
			
	
			$_SESSION['sv_checkindate'] = $this->checkInDate;
	
			$_SESSION['sv_checkoutdate'] = $this->checkOutDate;
	
			$_SESSION['sv_mcheckindate'] = $this->mysqlCheckInDate;
	
			$_SESSION['sv_mcheckoutdate'] = $this->mysqlCheckOutDate;
	
			$_SESSION['sv_nightcount'] = $this->nightCount;		
	
			$_SESSION['sv_guestperroom'] = $this->guestsPerRoom;		
	
			$_SESSION['svars_details'] = array();
	
		}
	
	
	
		
	
		private function invalidRequest(){
	
			header('Location: booking-failure.php?error_code=9');
	
			die;
	
		}
	
	
	
		private function getNightCount() {		
	
			$checkin_date = getdate(strtotime($this->mysqlCheckInDate));
	
			$checkout_date = getdate(strtotime($this->mysqlCheckOutDate));
	
			$checkin_date_new = mktime( 12, 0, 0, $checkin_date['mon'], $checkin_date['mday'], $checkin_date['year']);
	
			$checkout_date_new = mktime( 12, 0, 0, $checkout_date['mon'], $checkout_date['mday'], $checkout_date['year']);
	
			$this->nightCount = round(abs($checkin_date_new - $checkout_date_new) / 86400);
	
		}
	
	
	
	
	
		private function getDateRangeArray($startDate, $endDate, $nightAdjustment = true) {	
	
			$date_arr = array(); 
	
			$day_array=array(); 
	
			$total_array=array();
	
			 $time_from = mktime(0,0,0,substr($startDate,5,2), substr($startDate,8,2),substr($startDate,0,4));
	
			 $time_to = mktime(0,0,0,substr($endDate,5,2), substr($endDate,8,2),substr($endDate,0,4));		
	
			if ($time_to >= $time_from) { 
	
				if($nightAdjustment){
	
					while ($time_from < $time_to) {      
	
						array_push($date_arr, date('Y-m-d',$time_from));
	
						array_push($day_array, date('D',$time_from));
	
						$time_from+= 86400; // add 24 hours
	
					}
	
				}else{
	
					while($time_from <= $time_to) {      
	
						array_push($date_arr, date('Y-m-d',$time_from));
	
						array_push($day_array, $time_from);
	
						$time_from+= 86400; // add 24 hours
	
					}
	
				}			
	
			}  
	
			array_push($total_array, $date_arr);
	
			array_push($total_array, $day_array);
	
			return $total_array;		
	
		}
	
	
		private function checkBlock(){
			//$this->checkOutStamp += 100;
			//$this->checkInStamp += 100;
			$sblock = mysql_query('select b.nama,b.startdate,b.enddate,b.arrival, b.departure, a.tanggal  from blocking_detail a,blocking b where b.id=a.blockingid and a.tanggal = "'. $this->checkInStamp .'" and b.arrival="1" group by a.tanggal');
			
			if(mysql_num_rows($sblock)){
				$this->searchCode = "BLOCK_ARRIVAL";
				$rblock =mysql_fetch_array($sblock);
				$_SESSION[blockdesc]= $rblock[nama] ." -> ". date("d M Y",$rblock[startdate]) ." to ". date("d M Y",$rblock[enddate]);
				return 0;
				}
				
			$sblock1 = mysql_query('select b.nama,b.startdate,b.enddate,b.arrival, b.departure, a.tanggal  from blocking_detail a,blocking b where b.id=a.blockingid and a.tanggal = "'. $this->checkOutStamp .'" and b.departure="1" group by a.tanggal');
			if(mysql_num_rows($sblock1)){
				$this->searchCode = "BLOCK_DEPARTURE";
				$rblock1 =mysql_fetch_array($sblock1);
				$_SESSION[blockdesc]= $rblock1[nama] ." -> ". date("d M Y",$rblock1[startdate]) ." to ". date("d M Y",$rblock1[enddate]);
				return 0;
				}
			}
	
	
		private function checkSearchEngine(){
	
			global $bsiCore;
	
			if(intval($bsiCore->config['conf_booking_turn_off']) > 0){
	
				$this->searchCode = "SEARCH_ENGINE_TURN_OFF";
	
				return 0;
	
			}
	
	
	
			$diffrow = mysql_fetch_assoc(mysql_query("SELECT DATEDIFF('".$this->mysqlCheckOutDate."', '".$this->mysqlCheckInDate."') AS INOUTDIFF"));
	
			 $dateDiff = intval($diffrow['INOUTDIFF']);
	
			if($dateDiff < 0){
	
				$this->searchCode = "OUT_BEFORE_IN";
	
				return 0;
	
			}else if($dateDiff < intval($bsiCore->config['conf_min_night_booking'])){
	
				$this->searchCode = "NOT_MINNIMUM_NIGHT";
	
				return 0;
	
			}
	
	
	
			$userInputDate = strtotime($this->mysqlCheckInDate);
	
			$hotelDateTime = strtotime(date("Y-m-d"));
	
			$timezonediff =  ($userInputDate - $hotelDateTime);
	
			if($timezonediff < 0){
	
				$this->searchCode = "TIME_ZONE_MISMATCH";
	
				return 0;
	
			}		
	
		}
	
		public function extras(){
			$sext =mysql_query('select a.id, b.code as currency,  a.nama,a.descr,a.price from extras a, currency b where b.id = a.cur and a.startdate<="'. $this->checkInStamp .'" and a.enddate>="'. $this->checkOutStamp .'"');
			
			while($rext = mysql_fetch_array($sext)){
				array_push($this->addextras, array('id'=>$rext[id],'currency'=>$rext[currency],'nama'=>$rext[nama],'descr'=>$rext[descr],'price'=>$rext[price]));
				}
			}
	
		private function loadRoomTypes() {			
	
			$sql = mysql_query("SELECT * FROM bsi_roomtype");
	
			while($currentrow = mysql_fetch_assoc($sql)){	
	
				array_push($this->roomType, array('rtid'=>$currentrow["roomtype_ID"], 'rtname'=>$currentrow["type_name"]));
	
			}
			
			$sql1 = mysql_query('select * from roomtype  order by urut');
			while($currentrow = mysql_fetch_assoc($sql1)){	
	
				array_push($this->roomType1, array('rtid'=>$currentrow["id"], 'rtname'=>$currentrow["nama"], 'rtadult'=>$currentrow["adult"], 'rtchild'=>$currentrow["child"], 'descr'=>$currentrow["descr"]));
	
			}
			
			mysql_free_result($sql);
			
		}	
		
		private function loadPackage(){
		$stay =  ($this->checkOutStamp - $this->checkInStamp)/(3600*24) ;
	if($_POST['promocode']){
		$sqlcek1 = mysql_query('
		select id 
		from promo_code 
		where
		date_start <= '. $this->checkInStamp .' and date_end >= '. $this->checkOutStamp
		);
		$filter1a='';
		$filter1b='';
		$numrow1 = mysql_num_rows($sqlcek1);
		//echo 'Jumlah record ='. $numrow1 .'<br/>' ;
	
		if($numrow1){
		$filter1a = 'and b.date_start <= '. $this->checkInStamp .' and b.date_end >= '. $this->checkOutStamp;
		}
	
		$sqlcek2 = mysql_query('
		select id 
		from special_offer 
		where
		date_start <= '. $this->checkInStamp .' and date_end >= '. $this->checkOutStamp .' and 
		min_stay <= '. $stay .' and
		(
		(
		last_minute_time > '. ($this->checkInStamp - time())/86400 .' and last_minute_time > 0
		)
		or
		(
		leaddays < '.( $this->checkInStamp - time() )/86400 .' and leaddays > 0 
		)
		or
		(
		leaddays = 0 and last_minute_time = 0 
		)
		)'
		);

		$numrow2 = mysql_num_rows($sqlcek2);
		if($numrow2){
			$filter1b = 'and e.date_start <= '. $this->checkInStamp .' and e.date_end >= '. $this->checkOutStamp .' and 
		
			(
			e.min_stay <= '.( $this->checkOutStamp - $this->checkInStamp )/86400 .' and e.fix_los <> 1 
			or
			e.min_stay = '.( $this->checkOutStamp - $this->checkInStamp )/86400 .' and e.fix_los = 1 
			)
			and
			(
			(
			e.last_minute_time > '. ($this->checkInStamp - time())/86400 .' and e.last_minute_time > 0
			)
			or
			(
			e.leaddays < '.( $this->checkInStamp - time() )/86400 .' and e.leaddays > 0 
			)
			or
			(
			e.leaddays = 0 and e.last_minute_time = 0 
			)
			)';
		}
	
		if($numrow1 and $numrow2){
			$sqlpackage = '
			select a.*,
		(select c.id from promo_code c, promo_link d where c.id = b.id and d.id_package=a.id and c.id = d.id_promo) as promoid,	
		(select c.descr from promo_code c, promo_link d where c.id = b.id and d.id_package=a.id and c.id = d.id_promo) as promo,
		(select c.discount from promo_code c, promo_link d where c.id = b.id and d.id_package=a.id and c.id = d.id_promo) as discount,
		(select f.id from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerid,
		(select f.nama from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offername,
		(select f.descr from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerdescr,
		(select f.discount from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerdiscount
		from package a, promo_code b,special_offer e
		where b.promo_code = "'. $_POST['promocode'].'" ' . $filter1a .' '. $filter1b;
			}elseif($numrow1 and !$numrow2){
				$sqlpackage = '
			select a.*,
		(select c.id from promo_code c, promo_link d where c.id = b.id and d.id_package=a.id and c.id = d.id_promo) as promoid,	
		(select c.descr from promo_code c, promo_link d where c.id = b.id and d.id_package=a.id and c.id = d.id_promo) as promo,
		(select c.discount from promo_code c, promo_link d where c.id = b.id and d.id_package=a.id and c.id = d.id_promo) as discount
		from package a, promo_code b
		where b.promo_code = "'. $_POST['promocode'].'" ' . $filter1a ;
		
				}elseif(!$numrow1 and $numrow2){
				$sqlpackage = '
			select a.*,
		(select f.id from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerid,
		(select f.nama from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offername,
		(select f.descr from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerdescr,
		(select f.discount from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerdiscount
		from package a,special_offer e
		where a.id = a.id ' . $filter1b .' and ((e.min_stay <= '. $stay .' and e.fix_los<>1) or (e.min_stay = '. $stay .' and e.fix_los=1))';
				}
			
		$sql2 = mysql_query($sqlpackage);
		//echo 'Jumlah record = '.$sqlpackage;
		if(!mysql_num_rows($sql2)){
			$sql2 = mysql_query('select * from package');
			}
	}else{
		$sql2 = mysql_query('
		select a.*,
		(select f.id from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerid,
		(select f.nama from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offername,
		(select f.descr from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerdescr,
		(select f.discount from special_offer f, offer_link g where f.id = e.id and g.id_package=a.id and f.id = g.id_offer) as offerdiscount
		from package a, special_offer e
		where e.date_start <= '. $this->checkInStamp .' and e.date_end >= '. $this->checkOutStamp .' and
		(
		(
		e.last_minute_time > '. ($this->checkInStamp - time())/86400 .' and e.last_minute_time > 0
		)
		or
		(
		e.leaddays < '.( $this->checkInStamp - time() )/86400 .' and e.leaddays > 0 
		)
		or
		(
		e.leaddays = 0 and e.last_minute_time = 0 
		)
		) and ((e.min_stay <= '. $stay .' and e.fix_los<>1) or (e.min_stay = '. $stay .' and e.fix_los=1))'
		);
		if(!mysql_num_rows($sql2)){
			$sql2 = mysql_query('select * from package');
			}
	}
			
				while($currentrow = mysql_fetch_assoc($sql2)){	
		
					array_push($this->packageType, array('pkgid'=>$currentrow["id"], 'pkgname'=>$currentrow["nama"], 'pkgnamadesc'=>$currentrow["nama_desc"], 'pkgdescr'=>$currentrow["offerdescr"], 'pkgfulldescr'=>$currentrow["full_descr"], 'pkgstart'=>$currentrow["startdate"],'pkgend'=>$currentrow["enddate"],'pkgterm'=>$currentrow["term"],'pkgactive'=>$currentrow["active"],'promoname'=>$currentrow["promo"],'promodiscount'=>$currentrow["discount"],'specialoffer'=>$currentrow["offername"],'offerdiscount'=>$currentrow["offerdiscount"],'offerid'=>$currentrow["offerid"],'promoid'=>$currentrow["promoid"],'offerdescr'=>$currentrow["offerdescr"]));
				}
			mysql_free_result($sql2);
			}
	
		public function imageLoad($id){
			$rimg = 'select * from roomimage where roomid = "'. $id .'"';
			$resImg = mysql_query($rimg);
			//$xxx = 0;
			while ($rowImg = mysql_fetch_array($resImg)){
				if ($xxx==0){
					echo '<a class="imageroom" rel="'. $id .'" href="'. str_replace("http://reservation","http://reservation",$rowImg[files]) .'">';
					echo '<img src="'. str_replace("http://reservation","http://reservation",$rowImg[files])  .'" width="200" height="150" style="vertical-align:middle"  alt="Room Images"/>';
					echo '</a>';
					}
					echo '<a class="imageroom" rel="'. $id .'" href="'. str_replace("http://reservation","https://reservation",$rowImg[files])  .'">';
					echo '</a>';				
						//}
				$xxx+=1;
				}
			}
	
	
		private function loadMultiCapacity() {	
	
			$sql = mysql_query("SELECT * FROM bsi_capacity WHERE capacity >= ".$this->guestsPerRoom);
	
			while($currentrow = mysql_fetch_assoc($sql)){			
	
				$this->multiCapacity[$currentrow["id"]] = array('capval'=>$currentrow["capacity"],'captitle'=>$currentrow["title"]);
	
				
	
			}	
	
			mysql_free_result($sql);
	
		}
	
	
	
		
	
		public function getAvailableRoomsx($roomTypeId, $roomTypeName, $capcityid){
	
			global $bsiCore;		
	
			$currency_symbol = $bsiCore->config['conf_currency_symbol'];		
	
			$searchresult = array('roomtypeid'=>$roomTypeId, 'roomtypename'=>$roomTypeName, 'capacityid'=>$capcityid, 'capacitytitle'=>$this->multiCapacity[$capcityid]['captitle'], 'capacity'=>$this->multiCapacity[$capcityid]['capval'], 'maxchild'=>$this->childPerRoom);
	
	
	
			$room_count = 0;
	
			$dropdown_html = '<option value="0" selected="selected">0</option>';
	
			$price_details_html = '';
	
			$total_price_amount = 0;
	
			$calculated_extraprice = 0;
	
			$extraSearchParam = "";
	
	
	
			$searchsql = "
	
			SELECT rm.room_ID, rm.room_no
	
			  FROM bsi_room rm
	
			 WHERE rm.roomtype_id = ".$roomTypeId."
	
				   AND rm.capacity_id = ".$capcityid."".$extraSearchParam."
	
				   AND rm.room_id NOT IN
	
						  (SELECT resv.room_id
	
							 FROM bsi_reservation resv, bsi_bookings boks
	
							WHERE     boks.is_deleted = FALSE
	
								  AND resv.bookings_id = boks.booking_id
	
								  AND resv.room_type_id = ".$roomTypeId."
	
								  AND (('".$this->mysqlCheckInDate."' BETWEEN boks.start_date AND DATE_SUB(boks.end_date, INTERVAL 1 DAY))
	
								   OR (DATE_SUB('".$this->mysqlCheckOutDate."', INTERVAL 1 DAY) BETWEEN boks.start_date AND DATE_SUB(boks.end_date, INTERVAL 1 DAY))			   OR (boks.start_date BETWEEN '".$this->mysqlCheckInDate."' AND DATE_SUB('".$this->mysqlCheckOutDate."', INTERVAL 1 DAY))   					   OR (DATE_SUB(boks.end_date, INTERVAL 1 DAY) BETWEEN '".$this->mysqlCheckInDate."' AND DATE_SUB('".$this->mysqlCheckOutDate."', INTERVAL 1 DAY))))";
	
							   
	
			$sql = mysql_query($searchsql);
	
			$tmpctr = 1;
	
			$searchresult['availablerooms'] = array();
	
			while($currentrow = mysql_fetch_assoc($sql)){				
	
				$dropdown_html.= '<option value="'.$tmpctr.'">'.$tmpctr.'</option>';
	
				array_push($searchresult['availablerooms'], array('roomid'=>$currentrow["room_ID"], 'roomno'=>$currentrow["room_no"]));
	
				$tmpctr++;
	
			}
	
	
			mysql_free_result($sql);
	
			if($tmpctr > 1){
	
				$totalDays = $this->getDateRangeArray($this->mysqlCheckInDate, $this->mysqlCheckOutDate);	
	
				$totalamt3=0;
	
				 
	
				$dayName=array_count_values($totalDays[1]);
	
				$_month = date('M',strtotime($this->mysqlCheckInDate));
	
				$month_ = date('M',strtotime($this->mysqlCheckOutDate));
	
				$_color = '#f2f2f2';
	
				$color_ = '#f2f2f2';
	
				if($_month == $month_){
	
					$mon = $_month;
	
				}else{
	
					$mon = $_month.' - '.$month_;
	
				}
	
				 $price_details_html='<tr><td bgcolor='.$_color.'><b>Month</b></td>';
	
				  foreach($dayName as $days => $totalnum){
	
					 if($days == 'Sat' || $days == 'Sun'){
	
						 $price_details_html.='<td bgcolor='.$_color.'><b>'.$totalnum.' x '.$days.'</b></td>';
	
					 }else{
	
						 $price_details_html.='<td bgcolor='.$color_.'><b>'.$totalnum.' x '.$days.'</b></td>';
	
					 }
	
					 $$days=0;
	
				 }
	
				 $price_details_html.='<td bgcolor='.$color_.' align="right"><b>'.$this->nightCount.' Night(s)</b></td></tr>';
	
				 foreach($totalDays[0] as $date2 => $val){					
	
					$pricesql = mysql_query("SELECT * FROM bsi_priceplan WHERE roomtype_id = ".$roomTypeId." AND capacity_id = ".$capcityid." AND ('".$val."' BETWEEN start_date AND end_date)");
	
					if(mysql_num_rows($pricesql)){
	
						$row=mysql_fetch_assoc($pricesql);
	
					}else{
	
						$pricesql2 = mysql_query("SELECT * FROM bsi_priceplan WHERE roomtype_id = ".$roomTypeId." AND capacity_id = ".$capcityid." AND  default_plan=1");
	
						$row=mysql_fetch_assoc($pricesql2);
	
					}
	
					$day=date('D',strtotime($val));
	
					$$day+=$row[strtolower($day)];
	
				}
	
				$night_count_at_customprice = 0;	
	
				$searchresult['prices'] = array();	
	
				$price_details_html.='<tr>';
	
				if($bsiCore->config['conf_tax_amount'] > 0 && $bsiCore->config['conf_price_with_tax']==1){ 
	
					$price_details_html.='<td bgcolor='.$_color.'>'.$mon.'</td>';
	
					foreach($dayName as $days => $totalnum){
	
						$pricewithtax=$$days+(($$days * $bsiCore->config['conf_tax_amount'])/100);
	
						if($days == 'Sat' || $days == 'Sun'){
	
							$price_details_html.='<td bgcolor='.$_color.'>'.$currency_symbol.number_format($pricewithtax, 2 , '.', ',').'</td>';		
	
						}else{
	
							$price_details_html.='<td bgcolor='.$color_.'>'.$currency_symbol.number_format($pricewithtax, 2 , '.', ',').'</td>';					
	
						} 	
	
						$totalamt3=$totalamt3+number_format($pricewithtax, 2 , '.', ',');
	
					}
	
				 }else{
	
					$price_details_html.='<td bgcolor='.$_color.'>'.$mon.'</td>';					
	
					foreach($dayName as $days => $totalnum){
	
					   if($days == 'Sat' || $days == 'Sun'){						 
	
							$price_details_html.='<td bgcolor='.$_color.'>'.$currency_symbol.number_format($$days, 2 , '.', ',').'</td>';			
	
					   }else{ 
	
							$price_details_html.='<td bgcolor='.$color_.'>'.$currency_symbol.number_format($$days, 2 , '.', ',').'</td>';						
	
					   } 
	
					   $totalamt3=$totalamt3+$$days;				 
	
					} 
	
				 }
	
				 $total_price_amount=$totalamt3;
	
				 $price_details_html.='<td bgcolor='.$color_.' align="right">'.$currency_symbol.number_format($total_price_amount, 0 , '.', ',').'</td></tr>';
	
			}
	
			$searchresult['roomprice'] = $total_price_amount;				
	
			if($tmpctr > 1) array_push($_SESSION['svars_details'], $searchresult);
	
			unset($searchresult);
	
			
	
			return array(
	
			'roomcnt' => $tmpctr-1,		
	
			'roomdropdown' => $dropdown_html,
	
			'pricedetails' => $price_details_html,		
	
			'totalprice' => $total_price_amount); 
	
		}
		
		public function getAvailableRooms1x($roomTypeId, $roomTypeName,$capacity,$childs){
			
			global $bsiCore;		
	
			$currency_symbol = $bsiCore->config['conf_currency_symbol'];		
	
			$searchresult = array('roomtypeid'=>$roomTypeId, 'roomtypename'=>$roomTypeName, 'maxchild'=>$childs, 'capacity'=>$capacity );
	
	
			$room_count = 0;
	
			$dropdown_html = '<option value="0" selected="selected">0</option>';
	
			$price_details_html = '';
	
			$total_price_amount = 0;
	
			$calculated_extraprice = 0;
	
			$extraSearchParam = "";
	
	
	
			$searchsql = "
			
			select id, company, roomid,tanggal, Min(allotment) as avl ,publishrate,internetrate,included , block  allotment 
			
			from allotment
			
			where roomid=". $roomTypeId ." and 
			
			tanggal >= ". $this->checkInStamp ." and 
			
			tanggal <= ". $this->checkOutStamp ." and 
			
			allotment > 0  and
			internetrate > 0
			
			group by allotment";
	
	
							   
	
			$sql = mysql_query($searchsql);
	
			$tmpctr = 1;
	
			$searchresult['availablerooms'] = array();
	
			while($currentrow = mysql_fetch_assoc($sql)){				
	
				//$dropdown_html.= '<option value="'.$tmpctr.'">'.$tmpctr.'</option>';
	
				array_push($searchresult['availablerooms'], array('roomid'=>$currentrow["roomid"], 'allotment'=>$currentrow["allotment"]));
	
				$tmpctr++;
			}
			
			$sql = mysql_query($searchsql);
			$rowd = mysql_fetch_assoc($sql);
	
			for ($i=1;$i<=$rowd[avl];$i++ ){
				$dropdown_html.= '<option value="'.$i.'">'.$i.'</option>';
				}
				
			mysql_free_result($sql);
	
			if($tmpctr > 1){
	
				$totalDays = $this->getDateRangeArray($this->mysqlCheckInDate, $this->mysqlCheckOutDate);	
				
				$totalamt3=0;
	
				 
	
				$dayName=array_count_values($totalDays[1]);
	
				$_month = date('M',strtotime($this->mysqlCheckInDate));
	
				$month_ = date('M',strtotime($this->mysqlCheckOutDate));
	
				$_color = '#f2f2f2';
	
				$color_ = '#f2f2f2';
	
				if($_month == $month_){
	
					$mon = $_month;
	
				}else{
	
					$mon = $_month.' - '.$month_;
	
				}
	
				 $price_details_html='<tr><td bgcolor='.$_color.'><b>Month</b></td>';
	
				  foreach($dayName as $days => $totalnum){
	
					 if($days == 'Sat' || $days == 'Sun'){
	
						 $price_details_html.='<td bgcolor='.$_color.'><b>'.$totalnum.' x '.$days.'</b></td>';
	
					 }else{
	
						 $price_details_html.='<td bgcolor='.$color_.'><b>'.$totalnum.' x '.$days.'</b></td>';
	
					 }
	
					 $$days=0;
	
				 }
	
				 $price_details_html.='<td bgcolor='.$color_.' align="right"><b>'.$this->nightCount.' Night(s)</b></td></tr>';
	
				 foreach($totalDays[0] as $date2 => $val){					
					$currentdate = mktime(12,0,0,substr($val,5,2),substr($val,8,2),substr($val,0,4));
	
					$pricesql = mysql_query("SELECT * FROM allotment WHERE roomid = ".$roomTypeId." and tanggal >= ". $currentdate  );
	
					if(mysql_num_rows($pricesql)){
	
						$row=mysql_fetch_assoc($pricesql);
			
						$day=date('D',strtotime($val));
	
						$$day+=$row[internetrate];
					}
	
	
	
				}
	
				$night_count_at_customprice = 0;	
	
				//$searchresult['prices'] = array();	
	
				$price_details_html.='<tr>';
	
				if($bsiCore->config['conf_tax_amount'] > 0 && $bsiCore->config['conf_price_with_tax']==1){ 
	
					$price_details_html.='<td bgcolor='.$_color.'>'.$mon.'</td>';
	
					foreach($dayName as $days => $totalnum){
	
						$pricewithtax=$$days+(($$days * $bsiCore->config['conf_tax_amount'])/100);
	
						if($days == 'Sat' || $days == 'Sun'){
	
							$price_details_html.='<td bgcolor='.$_color.'>'.$currency_symbol.number_format($pricewithtax, 2 , '.', ',').'</td>';		
	
						}else{
	
							$price_details_html.='<td bgcolor='.$color_.'>'.$currency_symbol.number_format($pricewithtax, 2 , '.', ',').'</td>';					
	
						} 	
	
						//$totalamt3=$totalamt3+number_format($pricewithtax, 2 , '.', ',');
						$totalamt3=$totalamt3+$pricewithtax;
	
					}
					$roomprice = $totalamt3;
	
					$totalamt3=number_format($totalamt3, 2 , '.', ',');
	
				 }else{
	
					$price_details_html.='<td bgcolor='.$_color.'>'.$mon.'</td>';					
	
					foreach($dayName as $days => $totalnum){
	
					   if($days == 'Sat' || $days == 'Sun'){						 
	
							$price_details_html.='<td bgcolor='.$_color.'>'.$currency_symbol.number_format($$days, 2 , '.', ',').'</td>';			
	
					   }else{ 
	
							$price_details_html.='<td bgcolor='.$color_.'>'.$currency_symbol.number_format($$days, 2 , '.', ',').'</td>';						
	
					   } 
	
					   $totalamt3=$totalamt3+$$days;				 
	
					} 
					$roomprice = $totalamt3;
				 }
	
				 $total_price_amount=$totalamt3;
				
				 $price_details_html.='<td bgcolor='.$color_.' align="right">'.$currency_symbol. number_format($totalamt3,0,'.',',').'</td></tr>';
	
			}
	
			//$searchresult['roomprice'] = $roomprice;				
	
			if($tmpctr > 1) array_push($_SESSION['svars_details'], $searchresult);
	
			unset($searchresult);
	
			
	
			return array(
	
			'roomcnt' => $tmpctr-1,		
	
			'roomdropdown' => $dropdown_html,
	
			'pricedetails' => $price_details_html,		
	
			'totalprice' => $total_price_amount); 
			
		}
		
		public function getAvailableRooms2($roomTypeId, $roomTypeName,$capacity,$childs,$descr){
			
			global $bsiCore;		
	
			//$currency_symbol = $bsiCore->config['conf_currency_symbol'];		
	
			//$searchresult = array('roomtypeid'=>$roomTypeId, 'roomtypename'=>$roomTypeName, 'maxchild'=>$childs, 'capacity'=>$capacity,'descr'=>$descr );
	
	
			$room_count = 0;
	
			
	
			$searchsql = "
			
			select roomid, tanggal, block, allotment from allotment_room
			
			where roomid=". $roomTypeId ." and
			
			tanggal >= ". $this->checkInStamp ." and 
			
			tanggal < ". $this->checkOutStamp ." and 
					
			allotment > 0 and
			
			block <> 1";
							   
			$stay =  ($this->checkOutStamp - $this->checkInStamp)/(3600*24);
	
			$avl = "
			
			select  count(a.package) as reco,a.package,b.nama,b.nama_desc,  b.currency,a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b
			
			where a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.internetrate > 0
			
					
			group by a.package";
			
			$sql = mysql_query($searchsql);
	
			$tmpctr = 1;
	
			//$searchresult['availablerooms'] = array();
			$numrow = mysql_num_rows($sql);
			while($currentrow = mysql_fetch_assoc($sql)){				
	
				//$dropdown_html.= '<option value="'.$tmpctr.'">'.$tmpctr.'</option>';
	
				//array_push($searchresult['availablerooms'], array('roomid'=>$currentrow["roomid"], 'allotment'=>$currentrow["allotment"]));
	
				$tmpctr++;
			}
				
			mysql_free_result($sql);
	
			
	
			//$searchresult['roomprice'] = $roomprice;				
			
			if($tmpctr > 1) array_push($_SESSION['svars_details'], $searchresult);
	
			unset($searchresult);
	
	if($_POST['promocode']){
			$avl = "
			
			select  count(a.package) as reco,a.package,b.nama,b.nama_desc,  b.currency,a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b
			
			where a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.internetrate > 0 
					
			group by a.package";
	}else{
			$avl = "
			
			select  count(a.package) as reco,a.package,b.nama,b.nama_desc,  b.currency,a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b
			
			where a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.internetrate > 0
					
			group by a.package";
	}		
	
	
	
	
	
	
			$resavl = mysql_query($avl);
			$avail = 0;
			while($rowavl = mysql_fetch_array($resavl)){
					if($stay=$rowavl[reco])
					{
						$avail=1;
						}
				}
			
			if($numrow<>$stay or $avail==0){
				$tmpctr=1;
				}
			return array(
	
			'roomcnt' => $tmpctr-1); 
			
		}
		
		public function getAvailablepackage($roomTypeId, $pkgid,$pkgstart,$pkgend,$pkgactive,$offerid,$promoid){
			
			global $bsiCore;		

			//$currency_symbol = $bsiCore->config['conf_currency_symbol'];		
	
			$searchresult = array('roomtypeid'=>$roomTypeId, 'roomtypename'=>$roomTypeName, 'maxchild'=>$childs, 'capacity'=>$capacity,'descr'=>$descr );
	
	
			$room_count = 0;
	
			$dropdown_html = '<option value="0" selected="selected">0</option>';
	
			$price_details_html = '';
			
			$package_html = '';
			
			$package_price=0;
	
			$total_price_amount = 0;
			
			$package_allotment = '<option value="0" selected="selected">0</option>';
	
			$calculated_extraprice = 0;
	
			$extraSearchParam = "";
		
			$stay =  ($this->checkOutStamp - $this->checkInStamp)/(3600*24) ;
			$leaddays= ($this->checkInStamp-mktime(0,0,0,date("m"),date("d"),date("y")))/(3600*24) ;
			
			
	
			$searchsql1 = "
			
			select  a.package,min(d.allotment) as allotment, b.nama,b.nama_desc,b.leaddays, e.nama as roomname, c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block,d.tanggal  from allotment a, package b, currency c, allotment_room d, roomtype e
			
			where a.roomid=". $roomTypeId ." and
			
			e.id = a.roomid and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.package = ". $pkgid ." and
			a.internetrate > 0
			
			group by a.package order by e.urut";
			
			
			$searchsql = "
			
			select  a.package,min(d.allotment) as allotment, b.nama,b.nama_desc,b.leaddays, b.min_stay,e.nama as roomname, c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block,d.tanggal  
			
			,(select h.descr from promo_code h where h.id='". $promoid ."') as promo
			,(select h.id from promo_code h where h.id='". $promoid ."') as promoid
			,(select h.discount from promo_code h where h.id='". $promoid ."') as promodiscount
			,(select i.discount from special_offer i where i.id='". $offerid ."') as offerdiscount
			,(select i.id from special_offer i where i.id='". $offerid ."') as offerid
			
			from allotment a, package b, currency c, allotment_room d, roomtype e, promo_link f, offer_link k
			
			where (a.roomid=". $roomTypeId ." and
						
			e.id = a.roomid and k.id_offer = '". $offerid ."' and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.package = ". $pkgid ." and 
			
			b.fix_los <> 1 and
			
			b.min_stay <= ". $stay ." and
			a.internetrate > 0
			
			) or
			
			(a.roomid=". $roomTypeId ." and
			
			e.id = a.roomid and k.id_offer = '". $offerid ."' and
			
			f.id_package = b.id and
			
			k.id_package = b.id and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.package = ". $pkgid ." and 
			
			b.fix_los=1 and
			
			b.min_stay = ". $stay ." and
			a.internetrate > 0
			)
			
			group by a.package order by e.urut";
	
	
			$avl = "
			
			select  a.package,b.nama,b.nama_desc, c.nama as roomname,  b.currency,a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  
		
			
			from allotment a, package b, roomtype c
			
			where a.roomid=". $roomTypeId ." and
			
			c.id = a.roomid and
						
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			a.block <> 1 and
			
			b.id = a.package and
			
			b.min_stay <= ". $stay ." and
			
			a.internetrate > 0 and
			
			a.package = ". $pkgid ."  and
			a.internetrate > 0
			
			order by c.urut ";
	
			$sql = mysql_query($searchsql);
//	echo $searchsql."<br/>";
			$tmpctr = 1;
			$searchresult['availablepackage'] = array();
			while($currentrow = mysql_fetch_assoc($sql)){
				if($currentrow[leaddays]==0 or $currentrow[leaddays]<=$leaddays){				
				//$dropdown_html.= '<option value="'.$tmpctr.'">'.$tmpctr.'</option>';
				if($currentrow['promodiscount']>0 or $currentrow['offerdiscount']>0){
							$grandtotalpricex=$currentrow['internetrate'];
							if($currentrow['offerdiscount']>0){
								$grandtotalpricex=(100-$package['offerdiscount'])/100*$grandtotalpricex;
								}
							if($currentrow['promodiscount']>0){
								$grandtotalpricex=(100-$package['promodiscount'])/100*$grandtotalpricex;
								}
						}
				


				
				$package_price = $currentrow[currency]. " " . number_format($currentrow['internetrate'],0);
				//echo $currentrow[tanggal]." ". $this->checkInStamp;
				for($i=1;$i<=$currentrow[allotment];$i++){
					$package_allotment .= '<option value="'. $i .'">'.$i.'</option>';
					}
	
				array_push($searchresult['availablepackage'], array('pkgid'=>$currentrow["package"],'pkgname'=>$currentrow["nama"],'roomtypeid'=>$roomTypeId,'roomtypename'=>$currentrow["roomname"],'currency'=>$currentrow["currency"],'promoid'=>$currentrow["promoid"],'offerid'=>$currentrow["offerid"]));
				$tmpctr++;
				}
			}
	
			//$resavl = mysql_query($avl);
	
			$numrows = mysql_num_rows(mysql_query($searchsql));
			
			$sql = mysql_query($searchsql);
			$rowd = mysql_fetch_assoc($sql);
	
			//for ($i=1;$i<=$room_count;$i++ ){
			//	$dropdown_html.= '<option value="'.$i.'">'.$i.'</option>';
			//	}
				
			mysql_free_result($sql);
	
			if($tmpctr > 1){
	
				$totalDays = $this->getDateRangeArray($this->mysqlCheckInDate, $this->mysqlCheckOutDate);	
				
				$totalamt3=0;
	
				 
	
				$dayName=array_count_values($totalDays[1]);
	
				$_month = date('M',strtotime($this->mysqlCheckInDate));
	
				$month_ = date('M',strtotime($this->mysqlCheckOutDate));
	
				$_color = '#f2f2f2';
	
				$color_ = '#f2f2f2';
	
				if($_month == $month_){
	
					$mon = $_month;
	
				}else{
	
					$mon = $_month.' - '.$month_;
	
				}
	
				 $price_details_html='<tr><td bgcolor='.$_color.'><b>Month</b></td>';
	
				  foreach($dayName as $days => $totalnum){
	
					 if($days == 'Sat' || $days == 'Sun'){
	
						 $price_details_html.='<td bgcolor='.$_color.'><b>'.$totalnum.' x '.$days.'</b></td>';
	
					 }else{
	
						 $price_details_html.='<td bgcolor='.$color_.'><b>'.$totalnum.' x '.$days.'</b></td>';
	
					 }
	
					 $$days=0;
	
				 }
	
				 $price_details_html.='<td bgcolor='.$color_.' align="right"><b>'.$this->nightCount.' Night(s)</b></td></tr>';
				 foreach($totalDays[0] as $date2 => $val){					
					$currentdate = mktime(0,0,0,substr($val,5,2),substr($val,8,2),substr($val,0,4));
					$pricesql = "
			
			select  a.package,min(d.allotment) as allotment,a.tanggal, b.nama,b.nama_desc,  c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  
			
			,(select h.discount from promo_code h where h.id = '". $promoid ."' ) as promodiscount
			,(select i.discount from special_offer i where i.id = '". $offerid ."' ) as offerdiscount
			
			from allotment a, package b, currency c, allotment_room d, promo_code f, special_offer k
			
			where a.roomid=". $roomTypeId ." and
			
			a.tanggal = ". $currentdate ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal = a.tanggal and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package and
			
			a.internetrate > 0 and
			
			a.package = ". $pkgid ." order by a.internetrate";
					
					$pricesql = mysql_query($pricesql);
					if(mysql_num_rows($pricesql)){
	
						$row=mysql_fetch_assoc($pricesql);
			
						$day=date('D',strtotime($val));
						$day2=date('D',strtotime($val));
						
						$cur = $row[currency];
$internetrate=$row['internetrate'];
						if($row['promodiscount']>0 or $row['offerdiscount']>0){
							
							if($row['offerdiscount']>0){
								$internetrate=(100-$row['offerdiscount'])/100*$internetrate;
								}
							if($row['promodiscount']>0){
								$internetrate=(100-$row['promodiscount'])/100*$internetrate;
								}
						}
	
						$$day+=$row['internetrate'];
					}
	
	
				}
				$allotment = mysql_num_rows(mysql_query($avl));
					
				if($allotment<>$stay){
					//echo $numrows;
					
					$tmpctr=0;
					}
				$night_count_at_customprice = 0;	
	
				$searchresult['prices'] = array();	
	
				$price_details_html.='<tr>';
	
				if($bsiCore->config['conf_tax_amount'] > 0 && $bsiCore->config['conf_price_with_tax']==1){ 
	
					$price_details_html.='<td bgcolor='.$_color.'>'.$mon.'</td>';
	
					foreach($dayName as $days => $totalnum){
						$pricewithtax=$$days;//+(($$days * $bsiCore->config['conf_tax_amount'])/100);
						if($_SESSION['curcode'] <> $cur){
						 $checkcur = mysql_query('select * from currency where code ="'. $cur .'"');
						 $rcur = mysql_fetch_array($checkcur); 
						 
						 $checkcur2 = mysql_query('select * from currency where code ="'. $_SESSION['curcode'] .'"');
						 $rcur2 = mysql_fetch_array($checkcur2); 
						 $pricewithtax=$pricewithtax*$rcur['exchange']/$rcur2['exchange'];
						}else{
						$pricewithtax=$pricewithtax;
						}
	
						if($days == 'Sat' || $days == 'Sun'){
	
							$price_details_html.='<td bgcolor='.$_color.'>'.$_SESSION['curcode'] . " " .number_format($pricewithtax, 2 , '.', ',').'</td>';		
	
						}else{
	
							$price_details_html.='<td bgcolor='.$color_.'>'.$_SESSION['curcode'] . " " .number_format($pricewithtax, 2 , '.', ',').'</td>';					
	
						} 	
	
						//$totalamt3=$totalamt3+number_format($pricewithtax, 2 , '.', ',');
						$totalamt3=$totalamt3+$pricewithtax;
	
					}
					$roomprice = $totalamt3;
	
					//$totalamt3=number_format($totalamt3, 2 , '.', ',');
					$totalamt3=$totalamt3;
	
				 }else{
	
					$price_details_html.='<td bgcolor='.$_color.'>'.$mon.'</td>';					
	
					foreach($dayName as $days => $totalnum){
	
					   if($days == 'Sat' || $days == 'Sun'){
						   $rateday=$$days;
						   if($row['promodiscount']>0 or $row['offerdiscount']>0){
							
							if($row['offerdiscount']>0){
								$rateday=(100-$row['offerdiscount'])/100*$rateday;
								}
							if($row['promodiscount']>0){
								$rateday=(100-$row['promodiscount'])/100*$rateday;
								}
							}						 
	
							$price_details_html.='<td bgcolor='.$_color.'>'.$_SESSION['curcode']. " " .number_format($rateday, 2 , '.', ',').'</td>';			
	
					   }else{
							$rateday=$$days;
						   if($row['promodiscount']>0 or $row['offerdiscount']>0){

							if($row['offerdiscount']>0){
								$rateday=(100-$row['offerdiscount'])/100*$rateday;
								}
							if($row['promodiscount']>0){
								$rateday=(100-$row['promodiscount'])/100*$rateday;
								}
							}
						    
	
							$price_details_html.='<td bgcolor='.$color_.'>'.$_SESSION['curcode']. " " .number_format($rateday, 2 , '.', ',').'</td>';						
	
					   } 
	
					   $totalamt3=$totalamt3+$$days;				 
	
					} 
					$roomprice = $totalamt3;
				 }
	
				 $total_price_amount=$totalamt3;
							$totalamt3x=$totalamt3;				 
				 if($row['promodiscount']>0 or $row['offerdiscount']>0){

							if($row['offerdiscount']>0){
								$totalamt3x=(100-$row['offerdiscount'])/100*$totalamt3x;
								}
							if($row['promodiscount']>0){
								$totalamt3x=(100-$row['promodiscount'])/100*$totalamt3x;
								}
							}
								
				 $price_details_html.='<td bgcolor='.$color_.' align="right">'.$_SESSION['curcode']. " " .number_format($totalamt3x,2,'.',',').'</td></tr>';
	
			}
	
			$searchresult['roomprice'] = $roomprice;				
	
			if($tmpctr > 1) array_push($_SESSION['svars_details'], $searchresult);
	
			unset($searchresult);
	
			
			return array(
			
			'cur'=>$_SESSION['curcode'],
	
			'roomcnt' => $tmpctr-1,
			
			'package_allotment' =>$package_allotment,
			
			'package_price'=>$package_price,		
	
			'roomdropdown' => $dropdown_html,
	
			'pricedetails' => $price_details_html,	
	
			'totalprice' => $total_price_amount); 
			
		}
		
			public function getLowestpackage($roomTypeId){
				
				global $bsiCore;
				
				$lowest = '';
	if($_POST['promocode']){
	$sql1="select  a.package,max(a.internetrate) as lowestrate,a.internetrate as asli,max(c.exchange*a.internetrate) as murah, b.nama,b.nama_desc,  c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b, currency c, allotment_room d
			
			where a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package and
			a.internetrate > 0 
			
			group by a.package order by murah asc";
	}else{
	$sql1="select  a.package,max(a.internetrate) as lowestrate,a.internetrate as asli,max(c.exchange*a.internetrate) as murah, b.nama,b.nama_desc,  c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b, currency c, allotment_room d
			
			where a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package and
			a.internetrate > 0
			
			group by a.package order by murah asc";
	}			
	//echo $sql1;			
			
			$stay =  ($this->checkOutStamp - $this->checkInStamp)/(3600*24) ;
	if($_POST['promocode']){
			$sql="select  a.package,max(a.internetrate) as lowestrate,a.internetrate as asli,max(c.exchange*a.internetrate) as murah, b.nama,b.nama_desc,  c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b, currency c, allotment_room d
			
			where (a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package  and
			
			b.fix_los <> 1 and
			
			b.min_stay <= ". $stay ."  and
			a.internetrate > 0 
			) or
			
			(a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package  and
			
			b.fix_los = 1 and
			
			b.min_stay = ". $stay ." and
			a.internetrate > 0 
			) 
			
			group by a.package order by murah asc";
	}else{
			$sql="select  a.package,max(a.internetrate) as lowestrate,a.internetrate as asli,max(c.exchange*a.internetrate) as murah, b.nama,b.nama_desc,  c.code as currency, a.internetrate,b.descr, b.full_descr, b.term, b.min_stay, a.block  from allotment a, package b, currency c, allotment_room d
			
			where (a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package  and
			
			b.fix_los <> 1 and
			
			b.min_stay <= ". $stay ."  and
			a.internetrate > 0
			) or
			
			(a.roomid=". $roomTypeId ." and
			
			a.tanggal >= ". $this->checkInStamp ." and 
			
			a.tanggal < ". $this->checkOutStamp ." and 
			
			d.roomid =a.roomid and
			
			d.tanggal >= ". $this->checkInStamp ." and 
			
			d.tanggal < ". $this->checkOutStamp ." and 
			
			c.id = b.currency and
			
			a.block <> 1 and
			
			b.id = a.package  and
			
			b.fix_los = 1 and
			
			b.min_stay = ". $stay ." and
			a.internetrate > 0
			) 
			
			group by a.package order by murah asc";
	}		
	
			
			
			$sql = mysql_query($sql);
			while($currentrow = mysql_fetch_assoc($sql)){
				//echo number_format($currentrow["lowestrate"],2) . " - " . $currentrow["asli"];
	
						if($_SESSION['curcode'] <> $currentrow["currency"]){
						 $checkcur = mysql_query('select * from currency where code ="'. $currentrow["currency"] .'"');
						 $rcur = mysql_fetch_array($checkcur); 
						 
						 $checkcur2 = mysql_query('select * from currency where code ="'. $_SESSION['curcode'] .'"');
						 $rcur2 = mysql_fetch_array($checkcur2); 
						 $lowestrate=$currentrow["lowestrate"]*$rcur['exchange']/$rcur2['exchange'];
						}else{
						$lowestrate=$currentrow["lowestrate"];
						}
	
				//$lowest = $currentrow["nama"]." from <span style='color:#00AA00;font-weight:bold;font-size:16px'>". $_SESSION['curcode']."  ". number_format($lowestrate,2)."</span>";
				$lowest = "<span style='color:#00AA00;font-weight:bold;font-size:16px'>". $_SESSION['curcode']."  ". number_format($lowestrate,2)."</span>";
			}
		
			return array(
			'lowestrate' =>$lowest
			);
			
		}
	}
	
	
	?>